#ifndef SINGLETON_H_
#define SINGLETON_H_

class Singleton {

	// Zelimo samo jedan primerak => moramo da zabranimo bilo kakvu vrstu kopiranja - i pri inicijalizaciji i pri dodeli.
	Singleton(const Singleton&) = delete;
	Singleton& operator=(const Singleton&) = delete;

	// Tacka pristupa jedinstvenom objektu. Moze se koristiti i u zastitne svrhe (samo nekima omogucen pristup), u svrhe brojanja pristupa objektu i sl.
	static Singleton& getInstance() {
		if (uniqueObject == nullptr) {
			uniqueObject = new Singleton();
		}
		return *uniqueObject;
	}

private:
	// Samo klasa Singleton treba da moze da stvori objekat.
	Singleton() = default;

	// Polje koje cuva jedini objekat koji ce se stvoriti.
	static Singleton* uniqueObject;
};

Singleton* Singleton::uniqueObject = nullptr;

#endif

