#ifndef SINGLETON_STATIC_H_
#define SINGLETON_STATIC_H_


class SingletonStatic {
public:
	SingletonStatic(const SingletonStatic&) = delete;
	SingletonStatic& operator=(const SingletonStatic&) = delete;

	/* Static kljucna rec menja vezivanje promenljive - prostor za nju se alocira u prostoru za globalne promenljive i njena vrednost se ne menja izmedju razlicitih poziva funkcije.
		Ovde - pri prvom pozivu se poziva konstruktor za inicijalizaciju promenljive instance, i ta promenljiva sada oznacava novonastali objekat. 
		Svaki sledeci put kada se pozove funkcija getInstance, vidi se da ta je ta promenljiva vec inicijalizovana i ta "stara" vrednost se koristi dalje u telu funkcije. 
		Tako dobijamo ono sto nam treba za nas projektni uzorak - samo jednu instancu klase kojoj omogucavamo pristup.
	*/
	SingletonStatic& getInstance() {
		static SingletonStatic instance;
		return instance;
	}

private:
	SingletonStatic() = default;
};

#endif
