#ifndef STRATEGY_H_
#define STRATEGY_H_

// Apstraktna klasa koja apstrakuje sve konkretne strategije - kako bi one mogle da se zamenjuju u klasi klijenta.
class Strategy {
public:
	virtual void execute() = 0;
};

class ConcreteStrategyA : public Strategy {
public:
	void execute(){}
};

class ConcreteStrategyB : public Strategy {
public:
	void execute() {}
};

class Client {
public:
	Client() {}
	~Client() { delete strategy_; }

	// Strategija moze da se promeni
	void setStrategy(Strategy* s) {
		strategy_ = s;
	}

	// Strategija se koristi u ponasanju klijenta
	void doSomething() {
		strategy_->execute();
	}

private:
	// Klijent ima referencu na strategiju koju koristi.
	Strategy* strategy_ = nullptr;
};

#endif
